Index: code/trunk/src/orxonox/CameraManager.cc
===================================================================
--- code/trunk/src/orxonox/CameraManager.cc	(revision 9666)
+++ code/trunk/src/orxonox/CameraManager.cc	(revision 9667)
@@ -38,5 +38,5 @@
 #include "core/GameMode.h"
 #include "core/GraphicsManager.h"
-#include "core/ObjectList.h"
+#include "core/object/ObjectList.h"
 #include "tools/Shader.h"
 #include "graphics/Camera.h"
@@ -48,6 +48,4 @@
     CameraManager::CameraManager()
     {
-        RegisterRootObject(CameraManager);
-
         assert(GameMode::showsGraphics());
     }
Index: code/trunk/src/orxonox/CameraManager.h
===================================================================
--- code/trunk/src/orxonox/CameraManager.h	(revision 9666)
+++ code/trunk/src/orxonox/CameraManager.h	(revision 9667)
@@ -41,9 +41,8 @@
 #include "util/OgreForwardRefs.h"
 #include "util/Singleton.h"
-#include "core/OrxonoxClass.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport CameraManager : public Singleton<CameraManager>, public OrxonoxClass
+    class _OrxonoxExport CameraManager : public Singleton<CameraManager>
     {
             friend class Singleton<CameraManager>;
Index: code/trunk/src/orxonox/Level.cc
===================================================================
--- code/trunk/src/orxonox/Level.cc	(revision 9666)
+++ code/trunk/src/orxonox/Level.cc	(revision 9667)
@@ -43,7 +43,7 @@
 namespace orxonox
 {
-    CreateFactory(Level);
+    RegisterClass(Level);
 
-    Level::Level(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
+    Level::Level(Context* context) : BaseObject(context), Synchronisable(context), Context(context)
     {
         RegisterObject(Level);
Index: code/trunk/src/orxonox/Level.h
===================================================================
--- code/trunk/src/orxonox/Level.h	(revision 9666)
+++ code/trunk/src/orxonox/Level.h	(revision 9667)
@@ -41,8 +41,8 @@
 namespace orxonox
 {
-    class _OrxonoxExport Level : public BaseObject, public Synchronisable
+    class _OrxonoxExport Level : public BaseObject, public Synchronisable, public Context
     {
         public:
-            Level(BaseObject* creator);
+            Level(Context* context);
             virtual ~Level();
 
Index: code/trunk/src/orxonox/LevelInfo.cc
===================================================================
--- code/trunk/src/orxonox/LevelInfo.cc	(revision 9666)
+++ code/trunk/src/orxonox/LevelInfo.cc	(revision 9667)
@@ -242,5 +242,5 @@
     // LevelInfo
 
-    CreateFactory(LevelInfo);
+    RegisterClass(LevelInfo);
 
     /**
@@ -250,5 +250,5 @@
         The creator of this object.
     */
-    LevelInfo::LevelInfo(BaseObject* creator) : BaseObject(creator)
+    LevelInfo::LevelInfo(Context* context) : BaseObject(context)
     {
         RegisterObject(LevelInfo);
Index: code/trunk/src/orxonox/LevelInfo.h
===================================================================
--- code/trunk/src/orxonox/LevelInfo.h	(revision 9666)
+++ code/trunk/src/orxonox/LevelInfo.h	(revision 9667)
@@ -45,5 +45,5 @@
 #include <iostream>
 #include <fstream>
-#include "core/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox // tolua_export
@@ -61,5 +61,5 @@
     */
     class _OrxonoxExport LevelInfoItem // tolua_export
-        : virtual public OrxonoxClass
+        : virtual public OrxonoxInterface
     { // tolua_export
         public:
@@ -204,5 +204,5 @@
     {
         public:
-            LevelInfo(BaseObject* creator);
+            LevelInfo(Context* context);
             virtual ~LevelInfo();
 
Index: code/trunk/src/orxonox/LevelManager.cc
===================================================================
--- code/trunk/src/orxonox/LevelManager.cc	(revision 9666)
+++ code/trunk/src/orxonox/LevelManager.cc	(revision 9667)
@@ -37,8 +37,8 @@
 
 #include "util/ScopedSingletonManager.h"
+#include "core/config/CommandLineParser.h"
+#include "core/config/ConfigValueIncludes.h"
+#include "core/CoreIncludes.h"
 #include "core/ClassTreeMask.h"
-#include "core/CommandLineParser.h"
-#include "core/ConfigValueIncludes.h"
-#include "core/CoreIncludes.h"
 #include "core/Loader.h"
 #include "core/Resource.h"
@@ -59,5 +59,5 @@
     LevelManager::LevelManager()
     {
-        RegisterRootObject(LevelManager);
+        RegisterObject(LevelManager);
         this->setConfigValues();
 
Index: code/trunk/src/orxonox/LevelManager.h
===================================================================
--- code/trunk/src/orxonox/LevelManager.h	(revision 9666)
+++ code/trunk/src/orxonox/LevelManager.h	(revision 9667)
@@ -46,5 +46,5 @@
 
 #include "util/Singleton.h"
-#include "core/OrxonoxClass.h"
+#include "core/config/Configurable.h"
 
 // tolua_begin
@@ -67,5 +67,5 @@
     class _OrxonoxExport LevelManager
     // tolua_end
-        : public Singleton<LevelManager>, public OrxonoxClass
+        : public Singleton<LevelManager>, public Configurable
     { // tolua_export
             friend class Singleton<LevelManager>;
Index: code/trunk/src/orxonox/Main.cc
===================================================================
--- code/trunk/src/orxonox/Main.cc	(revision 9666)
+++ code/trunk/src/orxonox/Main.cc	(revision 9667)
@@ -36,5 +36,5 @@
 #include "Main.h"
 
-#include "core/CommandLineParser.h"
+#include "core/config/CommandLineParser.h"
 #include "core/Game.h"
 #include "core/LuaState.h"
Index: code/trunk/src/orxonox/MoodManager.cc
===================================================================
--- code/trunk/src/orxonox/MoodManager.cc	(revision 9666)
+++ code/trunk/src/orxonox/MoodManager.cc	(revision 9667)
@@ -30,5 +30,5 @@
 
 #include "util/ScopedSingletonManager.h"
-#include "core/ConfigValueIncludes.h"
+#include "core/config/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
 #include "core/Resource.h"
@@ -43,5 +43,5 @@
     MoodManager::MoodManager()
     {
-        RegisterRootObject(MoodManager);
+        RegisterObject(MoodManager);
         this->setConfigValues();
 
@@ -95,5 +95,5 @@
     MoodListener::MoodListener()
     {
-        RegisterRootObject(MoodListener);
+        RegisterObject(MoodListener);
     }
 
Index: code/trunk/src/orxonox/MoodManager.h
===================================================================
--- code/trunk/src/orxonox/MoodManager.h	(revision 9666)
+++ code/trunk/src/orxonox/MoodManager.h	(revision 9667)
@@ -34,5 +34,5 @@
 #include <string>
 #include "util/Singleton.h"
-#include "core/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
@@ -42,5 +42,5 @@
         The MoodListener class is aware of a change in themes and directs that info to dependent classes.
     */
-    class _OrxonoxExport MoodListener : virtual public OrxonoxClass
+    class _OrxonoxExport MoodListener : virtual public OrxonoxInterface
     {
         friend class MoodManager;
@@ -60,5 +60,5 @@
         The MoodManager class serves to allow for different musical themes in the game.
     */
-    class _OrxonoxExport MoodManager : public Singleton<MoodManager>, public OrxonoxClass
+    class _OrxonoxExport MoodManager : public Singleton<MoodManager>, public Configurable
     {
             friend class Singleton<MoodManager>;
@@ -74,5 +74,4 @@
 
         private:
-            ~MoodManager() {}
             void checkMoodValidity();
 
Index: code/trunk/src/orxonox/PawnManager.cc
===================================================================
--- code/trunk/src/orxonox/PawnManager.cc	(revision 9666)
+++ code/trunk/src/orxonox/PawnManager.cc	(revision 9667)
@@ -39,5 +39,5 @@
     PawnManager::PawnManager()
     {
-        RegisterRootObject(PawnManager);
+        RegisterObject(PawnManager);
     }
 
Index: code/trunk/src/orxonox/PlayerManager.cc
===================================================================
--- code/trunk/src/orxonox/PlayerManager.cc	(revision 9666)
+++ code/trunk/src/orxonox/PlayerManager.cc	(revision 9667)
@@ -43,5 +43,5 @@
     PlayerManager::PlayerManager()
     {
-        RegisterRootObject(PlayerManager);
+        RegisterObject(PlayerManager);
 
 //         this->getConnectedClients();
Index: code/trunk/src/orxonox/Radar.cc
===================================================================
--- code/trunk/src/orxonox/Radar.cc	(revision 9666)
+++ code/trunk/src/orxonox/Radar.cc	(revision 9667)
@@ -37,5 +37,5 @@
 
 //#include "util/Math.h"
-#include "core/ObjectList.h"
+#include "core/object/ObjectList.h"
 #include "core/command/ConsoleCommand.h"
 #include "interfaces/RadarListener.h"
Index: code/trunk/src/orxonox/Radar.h
===================================================================
--- code/trunk/src/orxonox/Radar.h	(revision 9666)
+++ code/trunk/src/orxonox/Radar.h	(revision 9667)
@@ -41,5 +41,5 @@
 #include <string>
 
-#include "core/ObjectListIterator.h"
+#include "core/object/ObjectListIterator.h"
 #include "interfaces/RadarViewable.h"
 #include "tools/interfaces/Tickable.h"
@@ -74,5 +74,5 @@
         void radarObjectChanged(RadarViewable* rv);
 
-        ObjectListIterator<RadarViewable> itFocus_;
+        ObjectList<RadarViewable>::iterator itFocus_;
         RadarViewable* focus_;
         std::map<std::string, RadarViewable::Shape> objectTypes_;
Index: code/trunk/src/orxonox/Scene.cc
===================================================================
--- code/trunk/src/orxonox/Scene.cc	(revision 9666)
+++ code/trunk/src/orxonox/Scene.cc	(revision 9667)
@@ -51,7 +51,7 @@
 namespace orxonox
 {
-    CreateFactory(Scene);
-
-    Scene::Scene(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
+    RegisterClass(Scene);
+
+    Scene::Scene(Context* context) : BaseObject(context), Synchronisable(context), Context(context)
     {
         RegisterObject(Scene);
Index: code/trunk/src/orxonox/Scene.h
===================================================================
--- code/trunk/src/orxonox/Scene.h	(revision 9666)
+++ code/trunk/src/orxonox/Scene.h	(revision 9667)
@@ -45,8 +45,8 @@
 namespace orxonox
 {
-    class _OrxonoxExport Scene : public BaseObject, public Synchronisable, public Tickable
+    class _OrxonoxExport Scene : public BaseObject, public Synchronisable, public Tickable, public Context
     {
         public:
-            Scene(BaseObject* creator);
+            Scene(Context* context);
             virtual ~Scene();
 
Index: code/trunk/src/orxonox/Test.cc
===================================================================
--- code/trunk/src/orxonox/Test.cc	(revision 9666)
+++ code/trunk/src/orxonox/Test.cc	(revision 9667)
@@ -28,5 +28,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/ConfigValueIncludes.h"
+#include "core/config/ConfigValueIncludes.h"
 #include "core/command/ConsoleCommand.h"
 #include "network/NetworkFunction.h"
@@ -36,5 +36,5 @@
 namespace orxonox
 {
-    CreateFactory ( Test );
+    RegisterClass ( Test );
 
     SetConsoleCommand("Test", "printV1", &Test::printV1).addShortcut();
@@ -56,5 +56,5 @@
     Test* Test::instance_ = 0;
 
-    Test::Test(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
+    Test::Test(Context* context) : BaseObject(context), Synchronisable(context)
     {
         assert(instance_==0);
Index: code/trunk/src/orxonox/Test.h
===================================================================
--- code/trunk/src/orxonox/Test.h	(revision 9666)
+++ code/trunk/src/orxonox/Test.h	(revision 9667)
@@ -46,5 +46,5 @@
   {
     public:
-      Test(BaseObject* creator);
+      Test(Context* context);
       virtual ~Test();
 
Index: code/trunk/src/orxonox/chat/ChatHistory.cc
===================================================================
--- code/trunk/src/orxonox/chat/ChatHistory.cc	(revision 9666)
+++ code/trunk/src/orxonox/chat/ChatHistory.cc	(revision 9667)
@@ -39,5 +39,4 @@
   /* constructor */
 #ifndef CHATTEST
-  //ChatHistory::ChatHistory( BaseObject* creator ) : BaseObject(creator)
   ChatHistory::ChatHistory()
 #else
Index: code/trunk/src/orxonox/chat/ChatListener.h
===================================================================
--- code/trunk/src/orxonox/chat/ChatListener.h	(revision 9666)
+++ code/trunk/src/orxonox/chat/ChatListener.h	(revision 9667)
@@ -32,5 +32,5 @@
 #include "OrxonoxPrereqs.h"
 
-#include "core/OrxonoxClass.h"
+#include "core/object/Listable.h"
 
 namespace orxonox
@@ -40,5 +40,5 @@
         message was sent through ChatManager.
     */
-    class _OrxonoxExport ChatListener : virtual public OrxonoxClass
+    class _OrxonoxExport ChatListener : virtual public Listable
     {
         friend class ChatManager;
Index: code/trunk/src/orxonox/chat/ChatManager.cc
===================================================================
--- code/trunk/src/orxonox/chat/ChatManager.cc	(revision 9666)
+++ code/trunk/src/orxonox/chat/ChatManager.cc	(revision 9667)
@@ -113,8 +113,9 @@
     // ChatListener                                                         //
     //////////////////////////////////////////////////////////////////////////
+    RegisterAbstractClass(ChatListener).inheritsFrom(Class(Listable));
 
     ChatListener::ChatListener()
     {
-        RegisterRootObject(ChatListener);
+        RegisterObject(ChatListener);
     }
 }
Index: code/trunk/src/orxonox/collisionshapes/CollisionShape.cc
===================================================================
--- code/trunk/src/orxonox/collisionshapes/CollisionShape.cc	(revision 9666)
+++ code/trunk/src/orxonox/collisionshapes/CollisionShape.cc	(revision 9667)
@@ -44,4 +44,5 @@
 namespace orxonox
 {
+    RegisterAbstractClass(CollisionShape).inheritsFrom(Class(BaseObject)).inheritsFrom(Class(Synchronisable));
 
     /**
@@ -49,7 +50,7 @@
         Constructor. Registers and initializes the object.
     */
-    CollisionShape::CollisionShape(BaseObject* creator)
-        : BaseObject(creator)
-        , Synchronisable(creator)
+    CollisionShape::CollisionShape(Context* context)
+        : BaseObject(context)
+        , Synchronisable(context)
     {
         RegisterObject(CollisionShape);
Index: code/trunk/src/orxonox/collisionshapes/CollisionShape.h
===================================================================
--- code/trunk/src/orxonox/collisionshapes/CollisionShape.h	(revision 9666)
+++ code/trunk/src/orxonox/collisionshapes/CollisionShape.h	(revision 9667)
@@ -58,5 +58,5 @@
     {
         public:
-            CollisionShape(BaseObject* creator);
+            CollisionShape(Context* context);
             virtual ~CollisionShape();
 
Index: code/trunk/src/orxonox/collisionshapes/CompoundCollisionShape.cc
===================================================================
--- code/trunk/src/orxonox/collisionshapes/CompoundCollisionShape.cc	(revision 9666)
+++ code/trunk/src/orxonox/collisionshapes/CompoundCollisionShape.cc	(revision 9667)
@@ -42,5 +42,5 @@
 namespace orxonox
 {
-    CreateFactory(CompoundCollisionShape);
+    RegisterClass(CompoundCollisionShape);
 
     /**
@@ -48,5 +48,5 @@
         Constructor. Registers and initializes the object.
     */
-    CompoundCollisionShape::CompoundCollisionShape(BaseObject* creator) : CollisionShape(creator)
+    CompoundCollisionShape::CompoundCollisionShape(Context* context) : CollisionShape(context)
     {
         RegisterObject(CompoundCollisionShape);
Index: code/trunk/src/orxonox/collisionshapes/CompoundCollisionShape.h
===================================================================
--- code/trunk/src/orxonox/collisionshapes/CompoundCollisionShape.h	(revision 9666)
+++ code/trunk/src/orxonox/collisionshapes/CompoundCollisionShape.h	(revision 9667)
@@ -58,5 +58,5 @@
     {
         public:
-            CompoundCollisionShape(BaseObject* creator);
+            CompoundCollisionShape(Context* context);
             virtual ~CompoundCollisionShape();
 
Index: code/trunk/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc
===================================================================
--- code/trunk/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc	(revision 9666)
+++ code/trunk/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc	(revision 9667)
@@ -37,9 +37,9 @@
 namespace orxonox
 {
-    WorldEntityCollisionShape::WorldEntityCollisionShape(WorldEntity* creator) : CompoundCollisionShape(creator)
+    WorldEntityCollisionShape::WorldEntityCollisionShape(Context* context) : CompoundCollisionShape(context)
     {
         RegisterObject(WorldEntityCollisionShape);
 
-        this->worldEntityOwner_ = creator;
+        this->worldEntityOwner_ = NULL;
         // suppress synchronisation
         this->setSyncMode(ObjectDirection::None);
Index: code/trunk/src/orxonox/collisionshapes/WorldEntityCollisionShape.h
===================================================================
--- code/trunk/src/orxonox/collisionshapes/WorldEntityCollisionShape.h	(revision 9666)
+++ code/trunk/src/orxonox/collisionshapes/WorldEntityCollisionShape.h	(revision 9667)
@@ -38,8 +38,10 @@
     {
         public:
-            WorldEntityCollisionShape(WorldEntity* creator);
+            WorldEntityCollisionShape(Context* context);
             virtual ~WorldEntityCollisionShape();
 
-            inline WorldEntity* getWorldEntityOwner()
+            inline void setWorldEntityOwner(WorldEntity* worldEntityOwner)
+                { this->worldEntityOwner_ = worldEntityOwner; }
+            inline WorldEntity* getWorldEntityOwner() const
                 { return this->worldEntityOwner_; }
 
Index: code/trunk/src/orxonox/controllers/AIController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/AIController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/AIController.cc	(revision 9667)
@@ -39,7 +39,7 @@
     const float AIController::ACTION_INTERVAL = 1.0f;
 
-    CreateFactory(AIController);
-
-    AIController::AIController(BaseObject* creator) : ArtificialController(creator)
+    RegisterClass(AIController);
+
+    AIController::AIController(Context* context) : ArtificialController(context)
     {
         RegisterObject(AIController);
Index: code/trunk/src/orxonox/controllers/AIController.h
===================================================================
--- code/trunk/src/orxonox/controllers/AIController.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/AIController.h	(revision 9667)
@@ -41,5 +41,5 @@
     {
         public:
-            AIController(BaseObject* creator);
+            AIController(Context* context);
             virtual ~AIController();
 
Index: code/trunk/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 9667)
@@ -45,5 +45,7 @@
     SetConsoleCommand("ArtificialController", "setbotlevel",      &ArtificialController::setAllBotLevel);
 
-    ArtificialController::ArtificialController(BaseObject* creator) : FormationController(creator)
+    RegisterClass(ArtificialController);
+
+    ArtificialController::ArtificialController(Context* context) : FormationController(context)
     {
         RegisterObject(ArtificialController);
Index: code/trunk/src/orxonox/controllers/ArtificialController.h
===================================================================
--- code/trunk/src/orxonox/controllers/ArtificialController.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/ArtificialController.h	(revision 9667)
@@ -39,5 +39,5 @@
     {
         public:
-            ArtificialController(BaseObject* creator);
+            ArtificialController(Context* context);
             virtual ~ArtificialController();
 
Index: code/trunk/src/orxonox/controllers/Controller.cc
===================================================================
--- code/trunk/src/orxonox/controllers/Controller.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/Controller.cc	(revision 9667)
@@ -33,7 +33,7 @@
 namespace orxonox
 {
-    CreateUnloadableFactory(Controller);
+    RegisterUnloadableClass(Controller);
 
-    Controller::Controller(BaseObject* creator) : BaseObject(creator)
+    Controller::Controller(Context* context) : BaseObject(context)
     {
         RegisterObject(Controller);
Index: code/trunk/src/orxonox/controllers/Controller.h
===================================================================
--- code/trunk/src/orxonox/controllers/Controller.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/Controller.h	(revision 9667)
@@ -42,5 +42,5 @@
 
         public:
-            Controller(BaseObject* creator);
+            Controller(Context* context);
             virtual ~Controller();
 
Index: code/trunk/src/orxonox/controllers/DroneController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/DroneController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/DroneController.cc	(revision 9667)
@@ -41,9 +41,9 @@
         Constructor.
     */
-    CreateFactory(DroneController);
+    RegisterClass(DroneController);
 
     const float DroneController::ACTION_INTERVAL = 1.0f;
 
-    DroneController::DroneController(BaseObject* creator) : ArtificialController(creator)
+    DroneController::DroneController(Context* context) : ArtificialController(context)
     {
         RegisterObject(DroneController);
Index: code/trunk/src/orxonox/controllers/DroneController.h
===================================================================
--- code/trunk/src/orxonox/controllers/DroneController.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/DroneController.h	(revision 9667)
@@ -33,5 +33,5 @@
 
 #include "AIController.h"
-#include "core/WeakPtr.h"
+#include "core/object/WeakPtr.h"
 #include "tools/interfaces/Tickable.h"
 
@@ -50,5 +50,5 @@
     {
         public:
-            DroneController(BaseObject* creator);
+            DroneController(Context* context);
             virtual ~DroneController();
 
Index: code/trunk/src/orxonox/controllers/FormationController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/FormationController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/FormationController.cc	(revision 9667)
@@ -56,6 +56,5 @@
     SetConsoleCommand("FormationController", "formationsize",    &FormationController::formationsize);
 
-
-
+    RegisterClass(FormationController);
 
     static const unsigned int STANDARD_MAX_FORMATION_SIZE = 9;
@@ -69,5 +68,5 @@
     static const float ROTATEFACTOR_FREE = 0.8f;
 
-    FormationController::FormationController(BaseObject* creator) : Controller(creator)
+    FormationController::FormationController(Context* context) : Controller(context)
     {
         RegisterObject(FormationController);
Index: code/trunk/src/orxonox/controllers/FormationController.h
===================================================================
--- code/trunk/src/orxonox/controllers/FormationController.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/FormationController.h	(revision 9667)
@@ -33,8 +33,7 @@
 
 #include <vector>
-#include "core/Super.h"
+#include "core/class/Super.h"
 
 #include "util/Math.h"
-#include "core/OrxonoxClass.h"
 #include "controllers/Controller.h"
 #include "worldentities/ControllableEntity.h"
@@ -47,5 +46,5 @@
 
       public:
-      FormationController(BaseObject* creator);
+      FormationController(Context* context);
 
       virtual ~FormationController();
Index: code/trunk/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/HumanController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/HumanController.cc	(revision 9667)
@@ -66,10 +66,10 @@
     SetConsoleCommand("HumanController", "myposition",             &HumanController::myposition    ).addShortcut();
 
-    CreateUnloadableFactory(HumanController);
+    RegisterUnloadableClass(HumanController);
 
     HumanController* HumanController::localController_s = 0;
     /*static*/ const float HumanController::BOOSTING_TIME = 0.1f;
 
-    HumanController::HumanController(BaseObject* creator) : FormationController(creator)
+    HumanController::HumanController(Context* context) : FormationController(context)
     {
         RegisterObject(HumanController);
Index: code/trunk/src/orxonox/controllers/HumanController.h
===================================================================
--- code/trunk/src/orxonox/controllers/HumanController.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/HumanController.h	(revision 9667)
@@ -44,5 +44,5 @@
     { // tolua_export
         public:
-            HumanController(BaseObject* creator);
+            HumanController(Context* context);
             virtual ~HumanController();
 
Index: code/trunk/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 9667)
@@ -56,10 +56,10 @@
     SetConsoleCommand("NewHumanController", "unfire",     &NewHumanController::unfire    ).keybindMode(KeybindMode::OnRelease).addShortcut();
 
-    CreateUnloadableFactory(NewHumanController);
+    RegisterUnloadableClass(NewHumanController);
 
     NewHumanController* NewHumanController::localController_s = 0;
 
-    NewHumanController::NewHumanController(BaseObject* creator)
-        : HumanController(creator)
+    NewHumanController::NewHumanController(Context* context)
+        : HumanController(context)
         , crossHairOverlay_(NULL)
         , centerOverlay_(NULL)
@@ -98,5 +98,5 @@
         if (GameMode::showsGraphics())
         {
-            crossHairOverlay_ = new OrxonoxOverlay(this);
+            crossHairOverlay_ = new OrxonoxOverlay(this->getContext());
             crossHairOverlay_->setBackgroundMaterial("Orxonox/Crosshair3");
             crossHairOverlay_->setSize(Vector2(overlaySize_, overlaySize_));
@@ -104,5 +104,5 @@
             //crossHairOverlay_->setAspectCorrection(true); not working
 
-            centerOverlay_ = new OrxonoxOverlay(this);
+            centerOverlay_ = new OrxonoxOverlay(this->getContext());
             centerOverlay_->setBackgroundMaterial("Orxonox/CenterOverlay");
             centerOverlay_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
@@ -112,5 +112,5 @@
             if (showDamageOverlay_)
             {
-                damageOverlayTop_ = new OrxonoxOverlay(this);
+                damageOverlayTop_ = new OrxonoxOverlay(this->getContext());
                 damageOverlayTop_->setBackgroundMaterial("Orxonox/DamageOverlayTop");
                 damageOverlayTop_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
@@ -118,5 +118,5 @@
                 damageOverlayTop_->hide();
 
-                damageOverlayRight_ = new OrxonoxOverlay(this);
+                damageOverlayRight_ = new OrxonoxOverlay(this->getContext());
                 damageOverlayRight_->setBackgroundMaterial("Orxonox/DamageOverlayRight");
                 damageOverlayRight_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
@@ -124,5 +124,5 @@
                 damageOverlayRight_->hide();
 
-                damageOverlayBottom_ = new OrxonoxOverlay(this);
+                damageOverlayBottom_ = new OrxonoxOverlay(this->getContext());
                 damageOverlayBottom_->setBackgroundMaterial("Orxonox/DamageOverlayBottom");
                 damageOverlayBottom_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
@@ -130,5 +130,5 @@
                 damageOverlayBottom_->hide();
 
-                damageOverlayLeft_ = new OrxonoxOverlay(this);
+                damageOverlayLeft_ = new OrxonoxOverlay(this->getContext());
                 damageOverlayLeft_->setBackgroundMaterial("Orxonox/DamageOverlayLeft");
                 damageOverlayLeft_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
@@ -139,5 +139,5 @@
             if (showArrows_)
             {
-                arrowsOverlay1_ = new OrxonoxOverlay(this);
+                arrowsOverlay1_ = new OrxonoxOverlay(this->getContext());
                 arrowsOverlay1_->setBackgroundMaterial("Orxonox/DirectionArrows1");
                 arrowsOverlay1_->setSize(Vector2(0.02727f, 0.36f * arrowsSize_));
@@ -146,5 +146,5 @@
                 arrowsOverlay1_->hide();
 
-                arrowsOverlay2_ = new OrxonoxOverlay(this);
+                arrowsOverlay2_ = new OrxonoxOverlay(this->getContext());
                 arrowsOverlay2_->setBackgroundMaterial("Orxonox/DirectionArrows2");
                 arrowsOverlay2_->setSize(Vector2(0.02727f, 0.59f * arrowsSize_));
@@ -153,5 +153,5 @@
                 arrowsOverlay2_->hide();
 
-                arrowsOverlay3_ = new OrxonoxOverlay(this);
+                arrowsOverlay3_ = new OrxonoxOverlay(this->getContext());
                 arrowsOverlay3_->setBackgroundMaterial("Orxonox/DirectionArrows3");
                 arrowsOverlay3_->setSize(Vector2(0.02727f, 0.77f * arrowsSize_));
@@ -160,5 +160,5 @@
                 arrowsOverlay3_->hide();
 
-                arrowsOverlay4_ = new OrxonoxOverlay(this);
+                arrowsOverlay4_ = new OrxonoxOverlay(this->getContext());
                 arrowsOverlay4_->setBackgroundMaterial("Orxonox/DirectionArrows4");
                 arrowsOverlay4_->setSize(Vector2(0.02727f, arrowsSize_));
Index: code/trunk/src/orxonox/controllers/NewHumanController.h
===================================================================
--- code/trunk/src/orxonox/controllers/NewHumanController.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/NewHumanController.h	(revision 9667)
@@ -42,5 +42,5 @@
     {
         public:
-            NewHumanController(BaseObject* creator);
+            NewHumanController(Context* context);
             virtual ~NewHumanController();
 
Index: code/trunk/src/orxonox/controllers/ScriptController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/ScriptController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/ScriptController.cc	(revision 9667)
@@ -32,7 +32,7 @@
 namespace orxonox
 {
-    CreateFactory(ScriptController);
+    RegisterClass(ScriptController);
 
-    ScriptController::ScriptController(BaseObject* creator) : ArtificialController(creator)
+    ScriptController::ScriptController(Context* context) : ArtificialController(context)
     {
         RegisterObject(ScriptController);
Index: code/trunk/src/orxonox/controllers/ScriptController.h
===================================================================
--- code/trunk/src/orxonox/controllers/ScriptController.h	(revision 9666)
+++ code/trunk/src/orxonox/controllers/ScriptController.h	(revision 9667)
@@ -38,5 +38,5 @@
     {
         public:
-            ScriptController(BaseObject* creator);
+            ScriptController(Context* context);
             virtual ~ScriptController() { }
 
Index: code/trunk/src/orxonox/controllers/WaypointController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/WaypointController.cc	(revision 9666)
+++ code/trunk/src/orxonox/controllers/WaypointController.cc	(revision 9667)
@@ -34,7 +34,7 @@
 namespace orxonox
 {
-    CreateFactory(WaypointController);
+    RegisterClass(WaypointController);
 
-    WaypointController::WaypointController(BaseObject* creator) : ArtificialController(creator)
+    WaypointController::WaypointController(Context* context) : ArtificialController(context)
     {
         RegisterObject(WaypointController);
